---
title: Statements and declarations
slug: Web/JavaScript/Reference/Statements
tags:
  - JavaScript
  - Landing page
  - Reference
  - statements
---
<div>{{jsSidebar("Statements")}}</div>

<p>JavaScript applications consist of statements with an appropriate syntax. A single statement may span multiple lines. Multiple statements may occur on a single line if each statement is separated by a semicolon. This isn't a keyword, but a group of keywords.</p>

<h2 id="Statements_and_declarations_by_category">Statements and declarations by category</h2>

<p>For an alphabetical listing see the sidebar on the left.</p>

<h3 id="Control_flow">Control flow</h3>

<dl>
 <dt>{{jsxref("Statements/block", "Block","",1)}}</dt>
 <dd>A block statement is used to group zero or more statements. The block is delimited by a pair of curly brackets.</dd>
 <dt>{{jsxref("Statements/break", "break")}}</dt>
 <dd>Terminates the current loop, switch, or label statement and transfers program control to the statement following the terminated statement.</dd>
 <dt>{{jsxref("Statements/continue", "continue")}}</dt>
 <dd>Terminates execution of the statements in the current iteration of the current or labeled loop, and continues execution of the loop with the next iteration.</dd>
 <dt>{{jsxref("Statements/Empty", "Empty","",1)}}</dt>
 <dd>An empty statement is used to provide no statement, although the JavaScript syntax would expect one.</dd>
 <dt>{{jsxref("Statements/if...else", "if...else")}}</dt>
 <dd>Executes a statement if a specified condition is true. If the condition is false, another statement can be executed.</dd>
 <dt>{{jsxref("Statements/switch", "switch")}}</dt>
 <dd>Evaluates an expression, matching the expression's value to a case clause, and executes statements associated with that case.</dd>
 <dt>{{jsxref("Statements/throw", "throw")}}</dt>
 <dd>Throws a user-defined exception.</dd>
 <dt>{{jsxref("Statements/try...catch", "try...catch")}}</dt>
 <dd>Marks a block of statements to try, and specifies a response, should an exception be thrown.</dd>
</dl>

<h3 id="Declarations">Declarations</h3>

<dl>
 <dt>{{jsxref("Statements/var", "var")}}</dt>
 <dd>Declares a variable, optionally initializing it to a value.</dd>
 <dt>{{jsxref("Statements/let", "let")}}</dt>
 <dd>Declares a block scope local variable, optionally initializing it to a value.</dd>
 <dt>{{jsxref("Statements/const", "const")}}</dt>
 <dd>Declares a read-only named constant.</dd>
</dl>

<h3 id="Functions_and_classes">Functions and classes</h3>

<dl>
 <dt>{{jsxref("Statements/function", "function")}}</dt>
 <dd>Declares a function with the specified parameters.</dd>
 <dt>{{jsxref("Statements/function*", "function*")}}</dt>
 <dd>Generator Functions enable writing <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">iterators</a> more easily.</dd>
 <dt>{{jsxref("Statements/async_function", "async function")}}</dt>
 <dd>Declares an async function with the specified parameters.</dd>
 <dt>{{jsxref("Statements/return", "return")}}</dt>
 <dd>Specifies the value to be returned by a function.</dd>
 <dt>{{jsxref("Statements/class", "class")}}</dt>
 <dd>Declares a class.</dd>
</dl>

<h3 id="Iterations">Iterations</h3>

<dl>
 <dt>{{jsxref("Statements/do...while", "do...while")}}</dt>
 <dd>Creates a loop that executes a specified statement until the test condition evaluates to false. The condition is evaluated after executing the statement, resulting in the specified statement executing at least once.</dd>
 <dt>{{jsxref("Statements/for", "for")}}</dt>
 <dd>Creates a loop that consists of three optional expressions, enclosed in parentheses and separated by semicolons, followed by a statement executed in the loop.</dd>
 <dt>{{jsxref("Statements/for_each...in", "for each...in")}} {{deprecated_inline}}</dt>
 <dd>Iterates a specified variable over all values of object's properties. For each distinct property, a specified statement is executed. This is deprecated, and you should use <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code> instead.</dd>
 <dt>{{jsxref("Statements/for...in", "for...in")}}</dt>
 <dd>Iterates over the enumerable properties of an object, in arbitrary order. For each distinct property, statements can be executed.</dd>
 <dt>{{jsxref("Statements/for...of", "for...of")}}</dt>
 <dd>Iterates over iterable objects (including {{jsxref("Global_Objects/Array","arrays","","true")}}, array-like objects, <a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators">iterators and generators</a>), invoking a custom iteration hook with statements to be executed for the value of each distinct property.</dd>
 <dt>{{jsxref("Statements/for-await...of", "for await...of")}}</dt>
 <dd>Iterates over async iterable objects, array-like objects, <a href="/en-US/docs/JavaScript/Guide/Iterators_and_Generators">iterators and generators</a>, invoking a custom iteration hook with statements to be executed for the value of each distinct property.</dd>
 <dt>{{jsxref("Statements/while", "while")}}</dt>
 <dd>Creates a loop that executes a specified statement as long as the test condition evaluates to true. The condition is evaluated before executing the statement.</dd>
</dl>

<h3 id="Others">Others</h3>

<dl>
 <dt>{{jsxref("Statements/debugger", "debugger")}}</dt>
 <dd>Invokes any available debugging functionality. If no debugging functionality is available, this statement has no effect.</dd>
 <dt>{{jsxref("Statements/export", "export")}}</dt>
 <dd>Used to export functions to make them available for imports in external modules, and other scripts.</dd>
 <dt>{{jsxref("Statements/import", "import")}}</dt>
 <dd>Used to import functions exported from an external module, another script.</dd>
 <dt>{{jsxref("Statements/label", "label", "", 1)}}</dt>
 <dd>Provides a statement with an identifier that you can refer to using a <code>break</code> or <code>continue</code> statement.</dd>
</dl>

<dl>
 <dt>{{jsxref("Statements/with", "with")}} </dt>
 <dd>Extends the scope chain for a statement.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-ecmascript-language-statements-and-declarations', 'ECMAScript Language: Statements and Declarations')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators">Operators</a></li>
</ul>
